extends Node

#export (PackedScene) var Ball
var Ball = preload("res://Ball.tscn")

var n_particles = 0
signal s_n_particles
signal s_ke

func _input(event):
	if event.is_action_pressed("click"):
		n_particles += 1
		#emit_signal("s_n_particles", n_particles)
		
		var new_ball = Ball.instance()
		new_ball.position = get_viewport().get_mouse_position()
		new_ball.linear_velocity = Vector2(rand_range(-500,500), rand_range(-500,500))
		new_ball.linear_damp = 0
		new_ball.angular_damp = 0
		new_ball.friction = 0
		
		add_child(new_ball)

# warning-ignore:unused_argument
func _process(delta):
	var ke = compute_total_ke()
	emit_signal("s_ke", ke)

func compute_ke(atom):
	var ke = 0.5 * atom.weight * (pow(atom.linear_velocity.x, 2) + pow(atom.linear_velocity.y, 2))
	return ke

func compute_total_ke():
	var tree = get_children()
	#print('tree=', tree)
	
	var ke = 0.0
	var n = 0
	
	for c in tree:
		if c.has_method('is_atom'):
			#print('c.get_node_name=', c)
			ke += compute_ke(c)
			n += 1
	emit_signal('s_n_particles', n)
	return ke